require 'rails_helper'

RSpec.describe Hermes::UserToken, type: :model do
  let(:user) { create(:user) }

  context 'expiring_at' do
    it 'ttl index delete old data' do
      Hermes::UserToken.remove_indexes
      Hermes::UserToken.create_indexes
      expect(Hermes::UserToken.collection.indexes.to_a.map { |i| i['name'] }).to include('expiring_at_1')

      Hermes::UserToken.create(user_id: user.id, token: 'token', expiring_at: Time.now)
      expect {
        sleep(70)
      }.to change { Hermes::UserToken.count }.from(1).to(0)
    end
  end
end
